﻿
Public Class MouseEvents_MessageFilter

    Implements IMessageFilter

    Private Const WM_PAINT As Integer = &HF
    Private Const WM_MOUSEMOVE As Integer = &H200
    Private Const WM_LBUTTONDOWN As Integer = &H201
    Private Const WM_LBUTTONUP As Integer = &H202
    Private Const WM_LBUTTONDBLCLK As Integer = &H203
    Private Const WM_RBUTTONDOWN As Integer = &H204
    Private Const WM_RBUTTONUP As Integer = &H205
    Private Const WM_RBUTTONDBLCLK As Integer = &H206
    Private Const WM_MBUTTONDOWN As Integer = &H207
    Private Const WM_MBUTTONUP As Integer = &H208
    Private Const WM_MBUTTONDBLCLK As Integer = &H209
    Private Const WM_MOUSEWHEEL As Integer = &H20A
    Private Const WM_MOUSEHOVER As Integer = &H2A1
    Private Const WM_MOUSELEAVE As Integer = &H2A3

    Private mParent As Control
    Private mTarget As Control

    Public Sub New(ByVal parent As Control, ByVal target As Control)
        mParent = parent
        mTarget = target
    End Sub

    Public Function PreFilterMessage(ByRef m As Message) As Boolean Implements IMessageFilter.PreFilterMessage
        '
        ' ----------------------------------------- cursor hover target Control ?
        If mParent Is Nothing Then Return False
        Dim child As Control = Nothing
        Try
            child = mParent.GetChildAtPoint(mParent.PointToClient(Cursor.Position))
        Catch
        End Try
        If child Is Nothing Then Return False
        If child IsNot mTarget Then Return False
        ' ----------------------------------------- decode message
        Select Case m.Msg
            Case WM_LBUTTONDBLCLK
                Form1.ChangeVideoMode()

            Case WM_MOUSEWHEEL
                Form1.ExecMouseWheel(CInt(m.WParam) \ 65536)

            Case WM_LBUTTONDOWN
                Form1.ExecLButtonDown()

            Case WM_RBUTTONUP
                Form1.ExecRbuttonUp()

            Case WM_MOUSEMOVE
                If CInt(m.WParam) = 1 Then
                    Form1.ExecLButtonMove()
                End If

            Case Else
                ' --------------------------------- message not executed - dispatch it
                Return False
        End Select

        ' ----------------------------------------- message executed - do not dispatch
        Return True
    End Function

End Class

